unit Unit0039;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    ColorDialog1: TColorDialog;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    procedure GCLS ;
    procedure GLINE ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GCLS ;
begin
   with Image1.Canvas do begin
      // ʂ
      with Pen do begin
         Mode  := pmCopy ;
         Color := clWhite;
         Style := psSolid;
         Width := 1;
      end;
      with Brush do begin
         Color := clWhite;
         Style := bsSolid;
      end;
      Rectangle(0,0,Image1.Width,Image1.Height);
   end;
end;

procedure TForm1.GLINE ;
var
   c : TColor ;
   l,w : integer ;
begin
   c := ColorDialog1.Color;
   l := ComboBox1.ItemIndex ;
   w := StrToInt(Edit1.Text);

   with Image1.Canvas do begin
      Pen.Width := w;
      Pen.Color := c;
      Case(l)of
      0: Pen.Style := psSolid;
      1: Pen.Style := psDash;
      2: Pen.Style := psDot;
      3: Pen.Style := psDashDot;
      4: Pen.Style := psDashDotDot;
      5: Pen.Style := psClear;
      end;
      MoveTo(10,50);
      LineTo(Image1.Width-10,50);
   end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   GCLS ;
end;

// Color
procedure TForm1.Button1Click(Sender: TObject);
begin
   ColorDialog1.Execute ;
end;

// DelphiŐ`
procedure TForm1.Button2Click(Sender: TObject);
begin
   GCLS ;
   GLINE ;
end;

// WindowsAPIŐ`
procedure TForm1.Button3Click(Sender: TObject);
var
   c,i,j,w : Integer ;
	pen : HPEN ;
   l : LOGBRUSH ;
begin
   GCLS ;
   c := Integer(ColorDialog1.Color);
   i := ComboBox1.ItemIndex ;
   Case(i)of
   1 : j := PS_DASH	;
   2 : j := PS_DOT ;
	3 : j := PS_DASHDOT ;
   4 : j := PS_DASHDOTDOT ;
   5 : j := PS_NULL ;
   else
     	 j := PS_SOLID ;
   end;
   j := j or PS_GEOMETRIC or PS_ENDCAP_SQUARE or PS_JOIN_MITER ;
   w := StrToInt(Edit1.Text);

   l.lbStyle := BS_SOLID ;
   l.lbColor := c ;
   l.lbHatch := 0 ;
	pen := ExtCreatePen(j,w,l,0,nil);
	SelectObject(Image1.Canvas.Handle,pen);

	i := GetBkMode(Image1.Canvas.Handle);
   SetBkMode(Image1.Canvas.Handle, TRANSPARENT);
	Windows.MoveToEx(Image1.Canvas.Handle, 50,50,nil);
   Windows.LineTo(Image1.Canvas.Handle, 150,50);
   Windows.LineTo(Image1.Canvas.Handle, 300,50);
   SetBkMode(Image1.Canvas.Handle, i);
   DeleteObject(pen);
end;

end.
